/**
 * Copyright (c) 2010, The Android-x86 Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// ****************** Copyright (c) 2014 by Gigaset Communications GmbH ******
// Filename : IEthernetManager.aidl
// Owner    : Karthick [STC]
//-------------------------------------------------------------------------
// Definition : It has Ethernet stack API's which is used by app.
//-------------------------------------------------------------------------
// 22-07-2013, Gigaset Communications GmbH
// Feature added for Ethernet stack API's which is used by app.
//*************************************************************************

package com.maxwell.net.ethernet;
import com.maxwell.net.ethernet.EthernetDevInfo;

interface IEthernetManager
{
    String[] getDeviceNameList();
    void setState(int state);
    int getState( );
    int getIntState( );
    boolean updateDevInfo(in EthernetDevInfo info);
    boolean isConfigured();
    EthernetDevInfo getSavedConfig();
    int getTotalInterface();
    void setMode(String mode);
    String getMode();
    void setNetType(String nettype);
    String getNetType();
    void resetInterface();
    void clearIPAddress();
    boolean startEth();
    boolean stopEth();
    boolean restartDSDT();
}
