//$Id: DefaultHandler.java 474 2012-01-23 03:07:14Z janb.webtide $
//Copyright 2008 Mort Bay Consulting Pty. Ltd.
//------------------------------------------------------------------------
//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//http://www.apache.org/licenses/LICENSE-2.0
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//========================================================================
//========================================================================
//Copyright (c) 2014 by Gigaset Communications GmbH
//Note:This file is modified by STC for Maxwell to start jetty on device boot
//Owner: Ravindra Singhai [STC]
//Change History
//[1] [Date: 2013-28-05] No need to Display Toasts
//========================================================================
//========================================================================
//========================================================================
//========================================================================

package org.mortbay.ijetty.util;

import org.mortbay.ijetty.R;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

public class IJettyToast
{
	private static boolean DBG = true;
	
    public static void showServiceToast(Context context, int messageId)
    {
        if (DBG == true)
		    showToast(context,messageId,Toast.LENGTH_SHORT);
	
	}

    private static void showToast(Context context, int messageId, int duration)
    {
        Toast toast = Toast.makeText(context, messageId, duration);;
        toast.show();
    }

    public static void showQuickToast(Context context, int messageId)
    {
        if (DBG == true)
		   showToast(context,messageId,Toast.LENGTH_SHORT);
    }
}
